>From 3b7f717e727f6635bd40997a8e12b0565c71343c Mon Sep 17 00:00:00 2001
From: Tristan Ross <tristan.ross@midstall.com>
Date: Mon, 29 Jul 2024 19:05:35 -0700
Subject: [PATCH] Support CMAKE_ASM_COMPILER usage

---
 source/CMakeLists.txt        | 4 ++--
 source/common/CMakeLists.txt | 1 +
 2 files changed, 3 insertions(+), 2 deletions(-)

diff --git a/source/CMakeLists.txt b/source/CMakeLists.txt
index bed98bb37..cc1b9a722 100755
--- a/source/CMakeLists.txt
+++ b/source/CMakeLists.txt
@@ -372,7 +372,7 @@ int main() { return 0; }")
     if (NOT (ARM64 OR CROSS_COMPILE_ARM64))
         check_cxx_compiler_flag(-mstackrealign CC_HAS_STACK_REALIGN)
         if (CC_HAS_STACK_REALIGN)
-            add_definitions(-mstackrealign)
+            add_compile_options($<$<COMPILE_LANGUAGE:CXX>:-mstackrealign>)
         endif()
     endif()
     # Disable exceptions. Reduce executable size, increase compability.
@@ -616,7 +616,7 @@ if((MSVC_IDE OR XCODE OR GCC) AND ENABLE_ASSEMBLY)
             list(APPEND ASM_OBJS ${ASM}.${SUFFIX})
             add_custom_command(
                 OUTPUT ${ASM}.${SUFFIX}
-                COMMAND ${CMAKE_CXX_COMPILER}
+                COMMAND ${CMAKE_ASM_COMPILER}
                 ARGS ${ARM_ARGS} -c ${ASM_SRC} -o ${ASM}.${SUFFIX}
                 DEPENDS ${ASM_SRC})
         endforeach()
diff --git a/source/common/CMakeLists.txt b/source/common/CMakeLists.txt
index 40c932966..5e94b86a5 100644
--- a/source/common/CMakeLists.txt
+++ b/source/common/CMakeLists.txt
@@ -16,6 +16,7 @@ endif(EXTRA_LIB)
 if(ENABLE_ASSEMBLY)
     set_source_files_properties(threading.cpp primitives.cpp pixel.cpp PROPERTIES COMPILE_FLAGS -DENABLE_ASSEMBLY=1)
     list(APPEND VFLAGS "-DENABLE_ASSEMBLY=1")
+    enable_language(ASM)
 endif(ENABLE_ASSEMBLY)
 
 if(ENABLE_ASSEMBLY AND X86)
-- 
2.44.1

